'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('@ciscospark/internal-plugin-encryption');

var _storageAdapterLocalStorage = require('@ciscospark/storage-adapter-local-storage');

var _storageAdapterLocalStorage2 = _interopRequireDefault(_storageAdapterLocalStorage);

var _sparkCore = require('@ciscospark/spark-core');

var _sparkCore2 = _interopRequireDefault(_sparkCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  clientId: _propTypes2.default.string.isRequired,
  clientSecret: _propTypes2.default.string.isRequired,
  doAuth: _propTypes2.default.bool,
  onAuth: _propTypes2.default.func,
  redirectUri: _propTypes2.default.string.isRequired,
  scope: _propTypes2.default.string.isRequired
};

var defaultProps = {
  doAuth: false,
  onAuth: function onAuth() {}
};

var SparkOAuth = function (_Component) {
  (0, _inherits3.default)(SparkOAuth, _Component);

  function SparkOAuth() {
    (0, _classCallCheck3.default)(this, SparkOAuth);
    return (0, _possibleConstructorReturn3.default)(this, (SparkOAuth.__proto__ || Object.getPrototypeOf(SparkOAuth)).apply(this, arguments));
  }

  (0, _createClass3.default)(SparkOAuth, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.spark = new _sparkCore2.default({
        config: {
          credentials: {
            oauth: {
              client_id: this.props.clientId,
              client_secret: this.props.clientSecret,
              scope: this.props.scope,
              redirect_uri: this.props.redirectUri
            }
          },
          storage: {
            boundedAdapter: new _storageAdapterLocalStorage2.default('ciscospark-embedded')
          }
        }
      });

      this.spark.listenToAndRun(this.spark, 'change:canAuthorize', function () {
        _this2.checkForOauthToken();
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.doAuth && nextProps.doAuth !== this.props.doAuth) {
        this.spark.authenticate();
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: 'checkForOauthToken',
    value: function checkForOauthToken() {
      var credentials = this.spark.credentials;


      if (credentials.canAuthorize && credentials.supertoken) {
        var supertoken = credentials.supertoken;


        this.props.onAuth(supertoken.access_token);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);
  return SparkOAuth;
}(_react.Component);

SparkOAuth.propTypes = propTypes;
SparkOAuth.defaultProps = defaultProps;

exports.default = SparkOAuth;